# include <stdio.h>
# include <stdlib.h>
# include <math.h>

# include "global.h"
# include "rand.h"

/* Regular fitness calculation procedure */
void calcFitnesses (population *pop, int size)
{
	int i, j, k_min;
	int flag;

	int *dominated_Num;			// ڼ¼Ⱥpopÿһ֧popеĸ
	int	*bedominated_Num;		// ڼ¼Ⱥpopÿһ屻popи֧Ŀ
	int	**dominated_Matrix;		// еÿһԪa[i][j]ȡֵ, 1ʾi֧j, -1ʾj֧i, 0ʾji֧
	int	*R_i;					// ڼ¼ȺpopÿһR(i)

	double **distance_Matrix;	// еÿһԪa[i][j]ȡֵʾij
	double d;
	double *D_i;				// ڼ¼ȺpopÿһD(i)
	double *kth_distance;	
	individual *ind;

                          /* ڴ */
/************************************************************************/
	dominated_Num = (int *) malloc (size * sizeof(int));
	bedominated_Num = (int *) malloc (size * sizeof(int));
	R_i = (int *) malloc (size * sizeof(int));
	D_i = (double *) malloc (size * sizeof(double));
	kth_distance = (double *) malloc (size * sizeof(double));
	dominated_Matrix = (int **) malloc (size * sizeof(int));
	distance_Matrix = (double **) malloc (size * size * sizeof(double));

	for (i = 0; i < size; i++)
	{
		dominated_Matrix[i] = (int *) malloc (size * sizeof(int));
		distance_Matrix[i] = (double *) malloc (size * sizeof(double));
	}
/************************************************************************/

	k_min = (int) floor (sqrt (popsize + archive_size));	// kĸ

                          /* ʼ */
/************************************************************************/
	for (i = 0; i < size; i++)
	{
		dominated_Num[i] = 0;
		bedominated_Num[i] = 0;
		R_i[i] = 0;
		D_i[i] = 0.0;
	}
/************************************************************************/

                          /* R(i) begin */
/************************************************************************/
	for (i = 0; i < size - 1; i++)
	{
		for (j = i + 1; j < size; j++)
		{
			flag = check_dominance (&(pop->ind[i]), &(pop->ind[j]));
			dominated_Matrix[i][j] = flag;
			dominated_Matrix[j][i] = -(flag);
			
			if (flag == 1)
			{
				dominated_Num[i] += 1;
				bedominated_Num[j] += 1;
			}
			if (flag == -1)
			{
				bedominated_Num[i] += 1;
				dominated_Num[j] += 1;
			}
		}
	}
	for (i = 0; i < size; i++)
	{
		for (j = 0; j < size; j++)
		{
			if (dominated_Matrix[i][j] == -1)
			{
				R_i[i] += dominated_Num[j];
			}
		}
	}
/************************************************************************/

                          /* D(i) begin */
/************************************************************************/
	for (i = 0; i < size; i++)	// distance_Matrix
	{
		distance_Matrix[i][i] = INF;
		for (j = i + 1; j < size; j++)
		{
			d = Euclidean_Distance(&(pop->ind[i]), &(pop->ind[j]));
			distance_Matrix[i][j] = d;
			distance_Matrix[j][i] = d;
		}
	}
	for (i = 0; i < size; i++)
	{
		kth_distance[i] = search_k_minimum (distance_Matrix[i], k_min, size);
	}
	for (i = 0; i < size; i++)
	{
		D_i[i] = 1.0 / (2.0 + kth_distance[i]);
	}
/************************************************************************/

                          /* óӦ */
/************************************************************************/
	for (i = 0; i < size; i++)
	{
		ind = &(pop->ind[i]);
		ind->fitness = R_i[i] + D_i[i];
	}
/************************************************************************/

                          /* ڴ */
/************************************************************************/
	free (dominated_Num);
	free (bedominated_Num);
	free (R_i);
	free (D_i);
	free (kth_distance);
	for (i = 0; i < size; i++)
	{
		free (dominated_Matrix[i]);
		free (distance_Matrix[i]);
	}
	free (distance_Matrix);
	free (dominated_Matrix);
/************************************************************************/
}

/* Calculate the fitness values of the individuals in the jumped population */
void calcFitnesses_Jump (population *pop, int size)
{
	int i, j, k_min;
	int flag;

	int *dominated_Num;			// ڼ¼Ⱥpopÿһ֧popеĸ
	int	*bedominated_Num;		// ڼ¼Ⱥpopÿһ屻popи֧Ŀ
	int	**dominated_Matrix;		// еÿһԪa[i][j]ȡֵ, 1ʾi֧j, -1ʾj֧i, 0ʾji֧
	int	*R_i;					// ڼ¼ȺpopÿһR(i)

	double **distance_Matrix;	// еÿһԪa[i][j]ȡֵʾij
	double d;
	double *D_i;				// ڼ¼ȺpopÿһD(i)
	double *kth_distance;	
	individual *ind;

	/* ڴ */
	/************************************************************************/
	dominated_Num = (int *) malloc (size * sizeof(int));
	bedominated_Num = (int *) malloc (size * sizeof(int));
	R_i = (int *) malloc (size * sizeof(int));
	D_i = (double *) malloc (size * sizeof(double));
	kth_distance = (double *) malloc (size * sizeof(double));
	dominated_Matrix = (int **) malloc (size * sizeof(int));
	distance_Matrix = (double **) malloc (size * size * sizeof(double));

	for (i = 0; i < size; i++)
	{
		dominated_Matrix[i] = (int *) malloc (size * sizeof(int));
		distance_Matrix[i] = (double *) malloc (size * sizeof(double));
	}
	/************************************************************************/

	k_min = (int) floor (sqrt (size));	// kĸ

	/* ʼ */
	/************************************************************************/
	for (i = 0; i < size; i++)
	{
		dominated_Num[i] = 0;
		bedominated_Num[i] = 0;
		R_i[i] = 0;
		D_i[i] = 0.0;
	}
	/************************************************************************/

	/* R(i) begin */
	/************************************************************************/
	for (i = 0; i < size - 1; i++)
	{
		for (j = i + 1; j < size; j++)
		{
			flag = check_dominance (&(pop->ind[i]), &(pop->ind[j]));
			dominated_Matrix[i][j] = flag;
			dominated_Matrix[j][i] = -(flag);

			if (flag == 1)
			{
				dominated_Num[i] += 1;
				bedominated_Num[j] += 1;
			}
			if (flag == -1)
			{
				bedominated_Num[i] += 1;
				dominated_Num[j] += 1;
			}
		}
	}
	for (i = 0; i < size; i++)
	{
		for (j = 0; j < size; j++)
		{
			if (dominated_Matrix[i][j] == -1)
			{
				R_i[i] += dominated_Num[j];
			}
		}
	}
	/************************************************************************/

	/* D(i) begin */
	/************************************************************************/
	for (i = 0; i < size; i++)	// distance_Matrix
	{
		distance_Matrix[i][i] = INF;
		for (j = i + 1; j < size; j++)
		{
			d = Euclidean_Distance(&(pop->ind[i]), &(pop->ind[j]));
			distance_Matrix[i][j] = d;
			distance_Matrix[j][i] = d;
		}
	}
	for (i = 0; i < size; i++)
	{
		kth_distance[i] = search_k_minimum (distance_Matrix[i], k_min, size);
	}
	for (i = 0; i < size; i++)
	{
		D_i[i] = 1.0 / (2.0 + kth_distance[i]);
	}
	/************************************************************************/

	/* óӦ */
	/************************************************************************/
	for (i = 0; i < size; i++)
	{
		ind = &(pop->ind[i]);
		ind->fitness = R_i[i] + D_i[i];
	}
	/************************************************************************/

	/* ڴ */
	/************************************************************************/
	free (dominated_Num);
	free (bedominated_Num);
	free (R_i);
	free (D_i);
	free (kth_distance);
	for (i = 0; i < size; i++)
	{
		free (dominated_Matrix[i]);
		free (distance_Matrix[i]);
	}
	free (distance_Matrix);
	free (dominated_Matrix);
	/************************************************************************/
}