# include <stdio.h>
# include <stdlib.h>
# include <math.h>
# include "time.h"

# include "global.h"
# include "rand.h"

void environmentalSelection (population *pop1,int size1,population *pop2,int size2, double *time1)
{
	int i, j;
	int num_nondominated;		// pop1з֧ĸ
	individual *ind, *ind1, *ind2, *temp_ind;
	population *temp_pop;
	int flag;
	double min, temp, start, end;

	temp_ind = (individual *) malloc (sizeof(individual));
	allocate_memory_ind (temp_ind);

	num_nondominated = 0;
	for (i = 0; i < size1; i++)		// ֧ĸ
	{
		ind = &(pop1->ind[i]);
		if (ind->fitness < 1.0)
		{
			num_nondominated += 1;
		}
	}
	if (num_nondominated <= size2)		// Ҫ޼ӵ
	{
		for (i = 0; i < size2; i++)
		{
			ind1 = &(pop1->ind[i]);
			min = ind1->fitness;
			flag = i;

			for (j = i + 1; j < size1; j++)
			{
				ind2 = &(pop1->ind[j]);
				temp = ind2->fitness;
				if (min > temp)
				{
					flag = j;
					min = temp;
				}
			}
			/*                      flag͸i                           */
			/************************************************************************/
			copy_ind (&(pop1->ind[i]), temp_ind);
			copy_ind (&(pop1->ind[flag]), &(pop1->ind[i]));
			copy_ind (temp_ind, &(pop1->ind[flag]));
			/************************************************************************/

			copy_ind (&(pop1->ind[i]), &(pop2->ind[i]));		// ӦСĸ忽pop2
		}
	}
	else	// Ҫ޼ӵ
	{
		j = 0;
		temp_pop = (population *) malloc (sizeof(population));
		allocate_memory_pop (temp_pop, num_nondominated);	
		start = clock ();
		for (i = 0; i < size1; i++)	//֧ĸ
		{
			ind = &(pop1->ind[i]);
			if (ind->fitness < 1.0)
			{
				copy_ind (&(pop1->ind[i]), &(temp_pop->ind[j]));
				j += 1;
			}
		}
		truncation_pop (temp_pop, num_nondominated, pop2, size2);
		end = clock ();
		*time1 += (double) (end - start) / CLOCKS_PER_SEC;
		deallocate_memory_pop (temp_pop, num_nondominated);
		free (temp_pop);
	}	
	deallocate_memory_ind (temp_ind);
	free (temp_ind);
}

/* Modified version of Enviromental Selection for Jumping Operation */
int environmentalSelection_jump (population *pop1,int size1,population *pop2,int size2, double *time1, population *jumping_pop)
{
	int i, j;
	int num_nondominated;		// pop1з֧ĸ
	individual *ind, *ind1, *ind2, *temp_ind;
	population *temp_pop;
	int flag;
	double min, temp, start, end;
	
	/* 14/12/2010 */
	int jump_size;

	jump_size = 0;

	temp_ind = (individual *) malloc (sizeof(individual));
	allocate_memory_ind (temp_ind);
	
	num_nondominated = 0;
	for (i = 0; i < size1; i++)		// ֧ĸ
	{
		ind = &(pop1->ind[i]);
		if (ind->fitness < 1.0)
		{
			num_nondominated += 1;
		}
	}
	if (num_nondominated <= size2)		// Ҫ޼ӵ
	{
		for (i = 0; i < size2; i++)
		{
			ind1 = &(pop1->ind[i]);
			min = ind1->fitness;
			flag = i;
			
			for (j = i + 1; j < size1; j++)
			{
				ind2 = &(pop1->ind[j]);
				temp = ind2->fitness;
				if (min > temp)
				{
					flag = j;
					min = temp;
				}
			}
/*                      flag͸i                           */
/************************************************************************/
			copy_ind (&(pop1->ind[i]), temp_ind);
			copy_ind (&(pop1->ind[flag]), &(pop1->ind[i]));
			copy_ind (temp_ind, &(pop1->ind[flag]));
/************************************************************************/

			copy_ind (&(pop1->ind[i]), &(pop2->ind[i]));		// ӦСĸ忽pop2
		}
	}
	else	// Ҫ޼ӵ
	{
		j = 0;
		temp_pop = (population *) malloc (sizeof(population));
		allocate_memory_pop (temp_pop, num_nondominated);	
		start = clock ();
		for (i = 0; i < size1; i++)	// ֧ĸ
		{
			ind = &(pop1->ind[i]);
			if (ind->fitness < 1.0)
			{
				copy_ind (&(pop1->ind[i]), &(temp_pop->ind[j]));
				j += 1;
			}
		}
//////////////////////////////////////////////////////////////////////////
		jump_size = num_nondominated - size2;
		allocate_memory_pop (jumping_pop, jump_size);
		truncation_pop_jump (temp_pop, num_nondominated, pop2, size2, jumping_pop, jump_size);
//////////////////////////////////////////////////////////////////////////
		end = clock ();
		*time1 += (double) (end - start) / CLOCKS_PER_SEC;
		deallocate_memory_pop (temp_pop, num_nondominated);
		free (temp_pop);
	}	
	deallocate_memory_ind (temp_ind);
	free (temp_ind);

	return jump_size;
}