# include <stdio.h>
# include <stdlib.h>
# include <math.h>

# include "global.h"
# include "rand.h"

 # define zdt1
// # define zdt2
// # define zdt4
// # define zdt6
// # define dtlz1
// # define dtlz2
// # define dtlz3
// # define dtlz4
// # define dtlz5
// # define dtlz6

double get_gd (population *pop)
{
	int i, j, k;
	int num_point;

	double gd;
	double distance, min_dist, dis_sum;
	double **obj_point;

	individual *ind1;

	dis_sum = 0.0;
	min_dist = 0.0;
	num_point = 10000;  /* Paretoȡĵ(10000)  6-obj ȡ100000 */

	allocate_memory (&obj_point, (num_point + 1));

	get_test_points (obj_point, num_point);

	for (k = 0; k < popsize; k++)
	{
		min_dist = INF;
		for (i = 0; i < num_point; i++)
		{
			distance = 0.0;
			ind1 = &(pop->ind[k]);
			for (j = 0; j < nobj; j++)
			{
				distance += pow ((obj_point[i][j] - ind1->obj[j]), 2.0);
			}
			distance = sqrt (distance);
			if (min_dist > distance)
			{
				min_dist = distance; 
			}
		}
		dis_sum += pow (min_dist, 2.0);
	}
	gd = sqrt (dis_sum) / popsize;

	Deallocate_memrory (obj_point, (num_point + 1));

	return gd;
}


double get_igd (population *pop)
{
	int i, j, k;
	int num_point;

	double igd;
	double distance, min_dist, dis_sum;
	double **obj_point;	

	individual *ind1;

	dis_sum = 0.0;
	min_dist = 0.0;
	num_point = 10000;  /* Paretoȡĵ(ά10000)  6-obj ȡ100000 */

	allocate_memory (&obj_point, (num_point + 1));

	get_test_points (obj_point, num_point);

	for (i = 0; i < num_point; i++)
	{
		min_dist = INF;
		for (k = 0; k < popsize; k++)
		{
			distance = 0.0;
			ind1 = &(pop->ind[k]);
			for (j = 0; j < nobj; j++)
			{
				distance += pow ((obj_point[i][j] - ind1->obj[j]), 2.0);
			}
			distance = sqrt (distance);
			if (min_dist > distance)
			{
				min_dist = distance;
			}
		}
		dis_sum += min_dist;
	}
	igd = dis_sum / num_point;

	Deallocate_memrory (obj_point, (num_point + 1));

	return igd;
}


#ifdef zdt1
void get_test_points (double** obj, int num)
{
	int i, j;
	double gx;

	for(i = 0; i < num;i++)
	{
		gx = 1;
		obj[i][0] = (1.0 - 0) * i / (num - 1);
		obj[i][1] = gx * (1.0 - sqrt (((1.0 - 0) * i / (num - 1)) / gx));
	}
}
#endif


#ifdef zdt2
void get_test_points (double** obj, int num)
{
	int i, j;
	double gx;

	for (i = 0; i < num; i++)
	{
		gx = 1;
		obj[i][0] = (1.0 - 0) * i / (num - 1);
		obj[i][1] = gx * (1.0 - pow (((1.0-0) * i / (num - 1)), 2.0));
	}
}
#endif


#ifdef zdt4
void get_test_points (double** obj, int num)
{
	int i, j;
	double gx;

	for (i = 0; i < num; i++)
	{
		gx = 1;
		obj[i][0] = (1.0 - 0) * i / (num - 1);
		obj[i][1] = gx * (1.0 - sqrt (((1.0 - 0) * i / (num - 1)) / gx));
	}
}
#endif


#ifdef zdt6
void get_test_points (double** obj, int num)
{
	int i, j, k;
	double gx;
	
	for (i = 0; i < num; i++)
	{
		gx = 1;
		obj[i][0] = 0.2807 + (1.0 - 0.2807) * i / (num - 1);
	}
	for (i = 0; i < num; i++)
	{
		obj[i][1] = 1 - pow (obj[i][0], 2); 
	}
}
#endif


#ifdef dtlz1
void get_test_points (double** obj, int num)
{
	int i, j, k;
	double x1, x2;	
	
	for (i = 0; i<= 99; i++)
	{
		x1 = (1.0 - 0.0) * i / 99;
		for (j = 0; j <= 99; j++)
		{
			x2 = (1.0 - 0.0) * j / 99;
			k = 100 * i + j;
			obj[k][0] = 0.5 * x1 * x2;
			obj[k][1] = 0.5 * x1 * (1 - x2);
			obj[k][2] = 0.5 * (1.0 - x1);			
		}
	}	
}
#endif


#ifdef dtlz2
void get_test_points (double** obj,int num)
{
	int i, j, k;
	double x1, x2;	
	
	for (i = 0; i <= 99; i++)
	{
		x1 = (1.0 - 0.0) * i / 99;
		for (j = 0; j <= 99; j++)
		{
			x2 = (1.0 - 0.0) * j / 99;
			k = 100 * i + j;
			obj[k][0] = cos (x1 * PI / 2.0) * cos (x2 * PI / 2.0);
			obj[k][1] = cos (x1 * PI / 2.0) * sin (x2 * PI / 2.0);
			obj[k][2] = sin (x1 * PI / 2.0);			
		}
	}
}
#endif


#ifdef dtlz3
void get_test_points (double** obj, int num)
{
	int i, j, k;
	double x1, x2;	
	
	for (i = 0; i <= 99; i++)
	{
		x1 = (1.0-0.0) * i / 99;
		for (j = 0; j <= 99; j++)
		{
			x2 = (1.0 - 0.0) * j / 99;
			k = 100 * i + j;
			obj[k][0] = cos (x1 * PI / 2.0) * cos (x2 * PI / 2.0);
			obj[k][1] = cos (x1 * PI / 2.0) * sin (x2 * PI / 2.0);
			obj[k][2] = sin (x1 * PI / 2.0);			
		}
	}	
}
#endif


#ifdef dtlz4
void get_test_points (double** obj, int num)
{
	int i, j, k;
	double x1, x2;	
	
	for (i = 0; i <= 99; i++)
	{
		x1 = (1.0 - 0.0) * i / 99;
		for (j = 0; j <= 99; j++)
		{
			x2 = (1.0 - 0.0) * j / 99;
			k = 100 * i + j;
			obj[k][0] = cos (x1 * PI / 2.0) * cos (x2 * PI / 2.0);
			obj[k][1] = cos (x1 * PI / 2.0) * sin (x2 * PI / 2.0);
			obj[k][2] = sin (x1 * PI / 2.0);			
		}
		
	}	
}
#endif


#ifdef dtlz5
void get_test_points(double** obj, int num)
{
	int i, j, k;	
	double x1, x2, x3;	

	x3 = PI / 4;
	for (i = 0; i <= num; i++)
	{
		x1 = (1.0 - 0.0) * i / (num - 1);
		obj[i][0] = cos (x1 * PI / 2.0) * cos (x3);
		obj[i][1] = cos (x1 * PI / 2.0) * sin (x3);
		obj[i][2] = sin (x1 * PI / 2.0);
	}
}
#endif


#ifdef dtlz6
void get_test_points (double** obj, int num)
{
	int i, j, k;
	double x1, x2, x3;	
	    
	x3 = PI / 4;
	for (i = 0; i <= num; i++)
	{
		x1 = (1.0 - 0.0) * i / (num - 1);
		obj[i][0] = cos (x1 * PI / 2.0) * cos (x3);
		obj[i][1] = cos (x1 * PI / 2.0) * sin (x3);
		obj[i][2] = sin (x1 * PI / 2.0);				
	}
}
#endif

/* ZDT3 is a special case that the Pareto optimal front should be read from a external file */
void gd_igd_zdt3 (population *pop)
{
	int i, j;
	int t_point;

	double pf[10001][2];
	double d, sum;
	double igd, gd;
	double dis_min;

	FILE *PF;
	FILE *outFile1;
	FILE *outFile2;

	d = 0.0;
	sum = 0.0;
	t_point = 2658;		/* zdt3ĵȡ2658 */

	outFile1 = fopen("gd.txt","a");
	outFile2 = fopen("igd.txt","a");

	/* ʵPareto */
	if ((PF = fopen(".//PF_Data//zdt3_PF.txt","r")) == NULL)
	{
		printf ("the file open failed!");
		exit (1);
	}

	i = 0;
	j = 0;
	while (!feof(PF) && i < t_point)
	{
		j = 0;
		fscanf (PF, "%lf", &pf[i][j]);
		j = 1;
		fscanf (PF, "%lf", &pf[i][j]);
		i++;
	}

	for (i = 0; i < popsize; i++)
	{
		dis_min = INF;
		for (j = 0; j < t_point; j++)
		{
			d = sqrt ((pop->ind[i].obj[0] - pf[j][0]) * (pop->ind[i].obj[0] - pf[j][0])+ (pop->ind[i].obj[1] - pf[j][1]) * (pop->ind[i].obj[1] - pf[j][1]));
			if (d < dis_min)
			{
				dis_min = d;
			}
		}
		sum += dis_min * dis_min;
	}

	gd = sqrt (sum) / popsize;
	fprintf (outFile1, "%lf\n", gd);

	d = 0.0;
	sum = 0.0;
	for (i = 0; i < t_point; i++)
	{
		dis_min = INF;
		for (j = 0;j < popsize; j++)
		{
			d = sqrt((pf[i][0] - pop->ind[j].obj[0]) * (pf[i][0] - pop->ind[j].obj[0]) + (pf[i][1] - pop->ind[j].obj[1]) * (pf[i][1] - pop->ind[j].obj[1]));
			if (d < dis_min)
			{
				dis_min = d;
			}
		}
		sum += dis_min;
	}

	igd = sum / t_point;

	fprintf(outFile2, "%lf\n", igd);

	fclose (PF);
	fclose (outFile1);
	fclose (outFile2);
}

/* DTLZ7 is a special case that the Pareto optimal front should be read from a external file */
void gd_igd_dtlz7 (population *pop)
{
	int i, j, k;
	int t_point;

	double pf[10001][3];
	double d, sum;
	double gd, igd;
	double dis_min;

	FILE *PF;
	FILE *outFile1;
	FILE *outFile2;

	d = 0.0;
	sum = 0.0;
	t_point = 9409;		/* dtlz7ĵȡ9409 */

	outFile1 = fopen ("gd.txt", "a");
	outFile2 = fopen ("igd.txt", "a");

	/* ʵPareto */
	if ((PF = fopen(".//PF_Data//paretoDTLZ7.dat","r")) == NULL)
	{
		printf ("the file open failed!");
		exit (1);
	}

	i = 0;
	j = 0;
	while (!feof(PF) && i < t_point)
	{
		j = 0;
		fscanf (PF, "%lf", &pf[i][j]);
		j = 1;
		fscanf (PF,"%lf", &pf[i][j]);
		j = 2;
		fscanf(PF,"%lf", &pf[i][j]);
		i++;
	}

	for (i = 0; i < popsize; i++)
	{
		dis_min = INF;
		for (j = 0; j < t_point; j++)
		{
			d = 0;
			for (k = 0; k < nobj; k++)
			{
				d += ((pop->ind[i].obj[k] - pf[j][k]) * (pop->ind[i].obj[k] - pf[j][k]));
			}
			d = sqrt (d);
			if (d < dis_min)
			{
				dis_min = d;
			}
		}
		sum += dis_min * dis_min;
	}

	gd = sqrt (sum) / popsize;
	fprintf (outFile1, "%lf\n", gd);

	d = 0.0;
	sum = 0.0;
	for (i = 0; i < t_point; i++)
	{
		dis_min = INF;
		for (j = 0; j < popsize; j++)
		{
			d = 0;
			for (k = 0; k < nobj; k++)
			{
				d += ((pf[i][k] - pop->ind[j].obj[k]) * (pf[i][k] - pop->ind[j].obj[k]));
			}
			d = sqrt (d);
			if (d < dis_min)
			{
				dis_min = d;
			}
		}
		sum += dis_min;
	}

	igd = sum / t_point;

	fprintf (outFile2, "%lf\n", igd);

	fclose (PF);
	fclose (outFile1);
	fclose (outFile2);
}