#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "global.h"
#include "rand.h"

void JumpingOperation (population *pop, population *new_pop, population *jumped_pop, int size)
{
	int i, j;
	int jumped_size;
	int dominance_flag;
	int temp_index_1, temp_index_2;
	int strategy_flag;
	double jrand;

	individual *temp_ind_1, *temp_ind_2, *temp_ind_3, *temp_ind_4, *temp_ind_5, *temp_ind_6;

	jumped_size = 0;
	dominance_flag = 0;

	temp_ind_1 = (individual *) malloc (sizeof(individual));
	temp_ind_2 = (individual *) malloc (sizeof(individual));
	temp_ind_3 = (individual *) malloc (sizeof(individual));
	temp_ind_4 = (individual *) malloc (sizeof(individual));
	temp_ind_5 = (individual *) malloc (sizeof(individual));
	temp_ind_6 = (individual *) malloc (sizeof(individual));

	allocate_memory_ind (temp_ind_1);
	allocate_memory_ind (temp_ind_2);
	allocate_memory_ind (temp_ind_3);
	allocate_memory_ind (temp_ind_4);
	allocate_memory_ind (temp_ind_5);
	allocate_memory_ind (temp_ind_6);

	if (size == 1)
	{
		jrand = rndreal (0.0, 1.0);
		if (jrand < jumping_rate)
		{
			/* cut and paste in the same chromosome */
			copy_ind (&pop->ind[0], temp_ind_1);
			CutPasteSame (temp_ind_1);
			copy_ind (temp_ind_1, &jumped_pop->ind[jumped_size]);
			jumped_size++;
			jumping_count++;

			/* Cut and paste in different chromosomes */
//////////////////////////////////////////////////////////////////////////
			copy_ind (&pop->ind[0], temp_ind_2);
			temp_index_1 = rnd (0, popsize - 1);		/* Select from the generated parent population */
			CutPasteDiff (temp_ind_2, &new_pop->ind[temp_index_1]);
			copy_ind (temp_ind_2, &jumped_pop->ind[jumped_size]);
			jumped_size++;
			jumping_count++;
//////////////////////////////////////////////////////////////////////////

			/* copy and paste in the same chromosome */
			copy_ind (&pop->ind[0], temp_ind_3);
			CopyPasteSame (temp_ind_3);
			copy_ind (temp_ind_3, &jumped_pop->ind[jumped_size]);
			jumped_size++;
			jumping_count++;

			/* Copy and paste in different chromosomes */
//////////////////////////////////////////////////////////////////////////
			copy_ind (&pop->ind[0], temp_ind_4);
			temp_index_1 = rnd (0, popsize - 1);		/* Select from the generated parent population */
			CopyPasteDiff (temp_ind_4, &new_pop->ind[temp_index_1]);
			copy_ind (temp_ind_4, &jumped_pop->ind[jumped_size]);
			jumped_size++;
			jumping_count++;
//////////////////////////////////////////////////////////////////////////
		}
		stop_index = jumped_size;	/* Keep record of the last position of jumped population */
	}
	else
	{
		for (i = 0; i < size; i++)
		{
			jrand = rndreal (0.0, 1.0);
			if (jrand < jumping_rate)
			{
				/* Cut and paste in the same chromosome */
//////////////////////////////////////////////////////////////////////////
				copy_ind (&pop->ind[i], temp_ind_1);
				CutPasteSame (temp_ind_1);
				copy_ind (temp_ind_1, &jumped_pop->ind[jumped_size]);
				jumped_size++;
				jumping_count++;
//////////////////////////////////////////////////////////////////////////

				/* Cut and paste in different chromosomes */
//////////////////////////////////////////////////////////////////////////
				copy_ind (&pop->ind[i], temp_ind_2);
				temp_index_1 = rnd (0, popsize - 1);		/* Select from the generated parent population */
				CutPasteDiff (temp_ind_2, &new_pop->ind[temp_index_1]);

				/* Select from the eliminated last level population */
				copy_ind (&pop->ind[i], temp_ind_3);
				do 
				{
					temp_index_2 = rnd (0, size - 1);
				} while (temp_index_2 == i);
				CutPasteDiff (temp_ind_3, &pop->ind[temp_index_2]);

				dominance_flag = check_dominance (temp_ind_2, temp_ind_3);
				if (dominance_flag == 1)
				{
					copy_ind (temp_ind_2, &jumped_pop->ind[jumped_size]);
					jumped_size++;
					jumping_count++;
				}
				else if (dominance_flag == -1)
				{
					copy_ind (temp_ind_3, &jumped_pop->ind[jumped_size]);
					jumped_size++;
					jumping_count++;
				}
				else
				{
					copy_ind (temp_ind_2, &jumped_pop->ind[jumped_size]);
					jumped_size++;
					copy_ind (temp_ind_3, &jumped_pop->ind[jumped_size]);
					jumped_size++;
					jumping_count += 2;
				}
//////////////////////////////////////////////////////////////////////////

				/* Copy and paste in the same chromosome */
//////////////////////////////////////////////////////////////////////////
				copy_ind(&pop->ind[i], temp_ind_4);
				CopyPasteSame (temp_ind_4);
				copy_ind (temp_ind_4, &jumped_pop->ind[jumped_size]);
				jumped_size++;
				jumping_count++;
//////////////////////////////////////////////////////////////////////////

				/* Copy and paste in different chromosomes */
//////////////////////////////////////////////////////////////////////////
				copy_ind (&pop->ind[i], temp_ind_5);
				temp_index_1 = rnd (0, popsize - 1);		/* Select from the generated parent population */
				CopyPasteDiff (temp_ind_5, &new_pop->ind[temp_index_1]);

				copy_ind (&pop->ind[i], temp_ind_6);
				/* Select from the eliminated last level population */
				do 
				{
					temp_index_2 = rnd (0, size - 1);
				} while (temp_index_2 == i);
				CopyPasteDiff (temp_ind_6, &pop->ind[temp_index_2]);

				dominance_flag = check_dominance (temp_ind_5, temp_ind_6);
				if (dominance_flag == 1)
				{
					copy_ind (temp_ind_5, &jumped_pop->ind[jumped_size]);
					jumped_size++;
					jumping_count++;
				}
				else if (dominance_flag == -1)
				{
					copy_ind (temp_ind_6, &jumped_pop->ind[jumped_size]);
					jumped_size++;
					jumping_count++;
				}
				else
				{
					copy_ind (temp_ind_5, &jumped_pop->ind[jumped_size]);
					jumped_size++;
					copy_ind (temp_ind_6, &jumped_pop->ind[jumped_size]);
					jumped_size++;
					jumping_count += 2;
				}
//////////////////////////////////////////////////////////////////////////

			}
		}
		stop_index = jumped_size;	/* Keep record of the last position of jumped population */
	}

	deallocate_memory_ind (temp_ind_1);
	deallocate_memory_ind (temp_ind_2);
	deallocate_memory_ind (temp_ind_3);
	deallocate_memory_ind (temp_ind_4);
	deallocate_memory_ind (temp_ind_5);
	deallocate_memory_ind (temp_ind_6);

	free (temp_ind_1);
	free (temp_ind_2);
	free (temp_ind_3);
	free (temp_ind_4);
	free (temp_ind_5);
	free (temp_ind_6);
}

/* Cut-and-Paste transposon in the same chromosome */
void CutPasteSame (individual *ind)
{
	int i, j;
	int flag;
	int left_size;				/* cut֮chromosomeĿ */
	int inserted_position;		/* λ */
	int current_index;
	double range;				/* ¼ضֵ */

	int *trans_position;		/* ¼transposonindex */
	int *cutted_position;		/* ¼cutʣindex */
	int *operated_position;		/* ¼Cut and Paste֮chromosomeindex */
	double *information;		/* ¼ÿһλõϢֵֹԽ */

	left_size = nreal - no_trans;

	trans_position = (int *) malloc (no_trans * sizeof(int));
	cutted_position = (int *) malloc (left_size * sizeof(int));
	operated_position = (int *) malloc (nreal * sizeof(int));
	information = (double *) malloc (nreal * sizeof(double));

	/* Record the individual's information */
/************************************************************************/
	for (i = 0; i < nreal; i++)
	{
		range = max_realvar[i] - min_realvar[i];
		information[i] = (ind->xreal[i] - min_realvar[i]) / range;
	}
/************************************************************************/

	/* Choose the transposon's position*/
/************************************************************************/
	for (i = 0; i < no_trans; i++)
	{
		do 
		{
			trans_position[i] = rnd (0, nreal - 1);
			flag = IsDuplicate (trans_position, trans_position[i], i);
		} while (flag == 1);
	}
/************************************************************************/

	/* Keep record on the left chromosome */ 
/************************************************************************/
	for (i = 0, j = 0; i < nreal; i++)
	{
		flag = IsInTransposon (trans_position, i);
		if (flag == 0)
		{
			cutted_position[j] = i;
			j++;
		}
	}
/************************************************************************/

	/* Select a insert position */
/************************************************************************/
	inserted_position = rnd (0, left_size);
/************************************************************************/

	/* Paste operation */
/************************************************************************/
	if (inserted_position == 0)
	{
		for (i = 0; i < no_trans; i++)
		{
			operated_position[i] = trans_position[i];
		}
		for (j = 0; j < left_size && i < nreal; i++, j++)
		{
			operated_position[i] = cutted_position[j];
		}
	}
	else
	{
		for (i = 0; i < inserted_position; i++)
		{
			operated_position[i] = cutted_position[i];
		}
		for (j = 0; j < no_trans && i < (inserted_position + no_trans); j++, i++)
		{
			operated_position[i] = trans_position[j];
		}
		for (j = inserted_position; j < left_size && i < nreal; j++, i++)
		{
			operated_position[i] = cutted_position[j];
		}
	}
/************************************************************************/

	/* Normalize the operated individual */
/************************************************************************/
	for (i = 0; i < nreal; i++)
	{
		current_index = operated_position[i];
		range = max_realvar[i] - min_realvar[i];
		ind->xreal[i] = range * information[current_index] + min_realvar[i];
	}
/************************************************************************/

	free (trans_position);
	free (cutted_position);
	free (operated_position);
	free (information);
}

/* Cut-and-Paste transposon in two different chromosome */
void CutPasteDiff (individual *ind1, individual *ind2)
{
	int i, j;
	int flag;
	int left_size;
	int inserted_position1, inserted_position2;		/* λ */
	int current_index1, current_index2;
	double range;									/* ¼ضֵ */

	int *logo1, *logo2;                             /*ʶgeneλǷ, 0  gene*/
	int *trans_position1, *trans_position2;			/* ¼transposonindex */
	int *cutted_position1, *cutted_position2;		/* ¼cutʣindex */
	int *operated_position1, *operated_position2;	/* ¼Cut and Paste֮chromosomeindex */
	double *information1, *information2;			/* ¼ÿһλõϢֵֹԽ */
	double *support;//

	left_size = nreal - no_trans;

	logo1 = (int *) malloc (nreal * sizeof(int));
	logo2 = (int *) malloc (nreal * sizeof(int));
	trans_position1 = (int *) malloc (no_trans * sizeof(int));
	trans_position2 = (int *) malloc (no_trans * sizeof(int));
	cutted_position1 = (int *) malloc (left_size * sizeof(int));
	cutted_position2 = (int *) malloc (left_size * sizeof(int));
	operated_position1 = (int *) malloc (nreal * sizeof(int));
	operated_position2 = (int *) malloc (nreal * sizeof(int));
	information1 = (double *) malloc (nreal * sizeof(double));
	information2 = (double *) malloc (nreal * sizeof(double));
	support = (double *) malloc (nreal * sizeof(double)); //

	/* Record the individuals' information */
/************************************************************************/
	for (i = 0; i < nreal; i++)
	{
		range = max_realvar[i] - min_realvar[i];
		information1[i] = (ind1->xreal[i] - min_realvar[i]) / range;
		information2[i] = (ind2->xreal[i] - min_realvar[i]) / range;
		support[i] = ind2->xreal[i];//
	}
/************************************************************************/

	/* Choose the transposons' positions*/
/************************************************************************/
	for (i = 0; i < no_trans; i++)
	{
		do 
		{
			trans_position1[i] = rnd (0, nreal - 1);
			flag = IsDuplicate (trans_position1, trans_position1[i], i);
		} while (flag == 1);
	}
	for (i = 0; i < no_trans; i++)
	{
		do 
		{
			trans_position2[i] = rnd (0, nreal - 1);
			flag = IsDuplicate (trans_position2, trans_position2[i], i);
		} while (flag == 1);
	}
/************************************************************************/

	/* Keep record on the left chromosomes */ 
/************************************************************************/
	for (i = 0, j = 0; i < nreal; i++)
	{
		flag = IsInTransposon (trans_position1, i);
		if (flag == 0)
		{
			cutted_position1[j] = i;
			j++;
		}
	}
	for (i = 0, j = 0; i < nreal; i++)
	{
		flag = IsInTransposon (trans_position2, i);
		if (flag == 0)
		{
			cutted_position2[j] = i;
			j++;
		}
	}
/************************************************************************/

	/* Select a insert positions */
/************************************************************************/
	inserted_position1 = rnd (0, left_size);
	inserted_position2 = rnd (0, left_size);
/************************************************************************/

	/* Paste operation */
/************************************************************************/
	for (i = 0; i < nreal; i++)
	{
		logo1[i] = 0;
		logo2[i] = 0;
	}

	if (inserted_position1 == 0)
	{
		for (i = 0; i < no_trans; i++)
		{
			operated_position1[i] = trans_position2[i];
			logo1[i] = 1;
		}
		for (j = 0; j < left_size && i < nreal; i++, j++)
		{
			operated_position1[i] = cutted_position1[j];
		}
	}
	else
	{
		for (i = 0; i < inserted_position1; i++)
		{
			operated_position1[i] = cutted_position1[i];
		}
		for (j = 0; j < no_trans && i < (inserted_position1 + no_trans); j++, i++)
		{
			operated_position1[i] = trans_position2[j];
			logo1[i] = 1;
		}
		for (j = inserted_position1; j < left_size && i < nreal; j++, i++)
		{
			operated_position1[i] = cutted_position1[j];
		}
	}
	/*
	if (inserted_position2 == 0)
	{
		for (i = 0; i < no_trans; i++)
		{
			operated_position2[i] = trans_position1[i];
		}
		for (j = 0; j < left_size && i < nreal; i++, j++)
		{
			operated_position2[i] = cutted_position2[j];
			logo2[i] = 1;
		}
	}
	else
	{
		for (i = 0; i < inserted_position2; i++)
		{
			operated_position2[i] = cutted_position2[i];
		}
		for (j = 0; j < no_trans && i < (inserted_position2 + no_trans); j++, i++)
		{
			operated_position2[i] = trans_position1[j];
			logo2[i] = 1;
		}
		for (j = inserted_position2; j < left_size && i < nreal; j++, i++)
		{
			operated_position2[i] = cutted_position2[j];
		}
	}
	*/
/************************************************************************/

	/* Normalize the operated individual */
/************************************************************************/
	for (i = 0; i < nreal; i++)
	{
		current_index1 = operated_position1[i];
		current_index2 = operated_position2[i];
		range = max_realvar[i] - min_realvar[i];
		if (logo1[i])
		{
			ind1->xreal[i] = range * information2[current_index1] + min_realvar[i];
		}
		else
		{
			ind1->xreal[i] = range * information1[current_index1] + min_realvar[i];
		}
		/*
		if (logo2[i])
		{
			ind2->xreal[i] = range * information1[current_index2] + min_realvar[i];
		}
		else
		{
			ind2->xreal[i] = range * information2[current_index2] + min_realvar[i];
		}
		*/
	    ind2->xreal[i] = support[i];//
	}
/************************************************************************/

	free (logo1);
	free (logo2);
	free (trans_position1);
	free (trans_position2);
	free (cutted_position1);
	free (cutted_position2);
	free (operated_position1);
	free (operated_position2);
	free (information1);
	free (information2);
	free (support);
}

/* Copy-and-Paste transposon in the same chromosome */
void CopyPasteSame (individual *ind)
{
	int i, j;
	int flag;
	int left_size;
	int inserted_position;		/* λ */
	int current_index;
	double range;				/* ¼ضֵ */
	int *trans_position;		/* ¼transposonindex */
	int *operated_position;		/* ¼Cut and Paste֮chromosomeindex */
	double *information;		/* ¼ÿһλõϢֵֹԽ */

	trans_position = (int *) malloc (no_trans * sizeof(int));
	operated_position = (int *) malloc (nreal * sizeof(int));
	information = (double *) malloc (nreal * sizeof(double));

	/* Record the individual's information */
/************************************************************************/
	for (i = 0; i < nreal; i++)
	{
		range = max_realvar[i] - min_realvar[i];
		information[i] = (ind->xreal[i] - min_realvar[i]) / range;
	}
/************************************************************************/

	/* Choose the transposon's position*/
/************************************************************************/
	for (i = 0; i < no_trans; i++)
	{
		do 
		{
			trans_position[i] = rnd (0, nreal - 1);
			flag = IsDuplicate (trans_position, trans_position[i], i);
		} while (flag == 1);
	}
/************************************************************************/

	/* Select a insert position */
/************************************************************************/
	inserted_position = rnd (0, nreal - 1);
	left_size = nreal - inserted_position;
/************************************************************************/

	/* Keep record of the original position */
/************************************************************************/
	for (i = 0; i < nreal; i++)
	{
		operated_position[i] = i;
	}
/************************************************************************/

	/* Paste operation */
/************************************************************************/
	if (left_size >= no_trans)
	{
		for (i = 0, j = inserted_position; i < no_trans; i++, j++)
		{
			operated_position[j] = trans_position[i];
		}
	}
	else
	{
		for (i = 0, j = inserted_position; i < no_trans && j < nreal; i++, j++)
		{
			operated_position[j] = trans_position[i];
		}
		for (j = 0; i < no_trans; i++, j++)
		{
			operated_position[j] = trans_position[i];
		}
	}
/************************************************************************/

	/* Normalize the operated individual */
/************************************************************************/
	for (i = 0; i < nreal; i++)
	{
		current_index = operated_position[i];
		range = max_realvar[i] - min_realvar[i];
		ind->xreal[i] = range * information[current_index] + min_realvar[i];
	}
/************************************************************************/

	free (trans_position);
	free (operated_position);
	free (information);
}

/* Copy-and-Paste transposon in two different chromosome */
void CopyPasteDiff (individual *ind1, individual *ind2)
{
	int i, j;
	int flag;
	int left_size1, left_size2;
	int inserted_position1, inserted_position2;		/* λ */
	int current_index1, current_index2;
	double range;					/* ¼ضֵ */

	int *logo1, *logo2;                             /*ʶgeneλǷ, 0  gene*/
	int *trans_position1, *trans_position2;			/* ¼transposonindex */
	int *operated_position1, *operated_position2;	/* ¼Cut and Paste֮chromosomeindex */
	double *information1, *information2;			/* ¼ÿһλõϢֵֹԽ */
	double *support;//

	logo1 = (int *) malloc (nreal * sizeof(int));
	logo2 = (int *) malloc (nreal * sizeof(int));
	trans_position1 = (int *) malloc (no_trans * sizeof(int));
	trans_position2 = (int *) malloc (no_trans * sizeof(int));
	operated_position1 = (int *) malloc (nreal * sizeof(int));
	operated_position2 = (int *) malloc (nreal * sizeof(int));
	information1 = (double *) malloc (nreal * sizeof(double));
	information2 = (double *) malloc (nreal * sizeof(double));
	support = (double *) malloc (nreal * sizeof(double));//

	/* Record the individual's information */
/************************************************************************/
	for (i = 0; i < nreal; i++)
	{
		range = max_realvar[i] - min_realvar[i];
		information1[i] = (ind1->xreal[i] - min_realvar[i]) / range;
		information2[i] = (ind2->xreal[i] - min_realvar[i]) / range;
		support[i] = ind2->xreal[i];//
	}
/************************************************************************/

	/* Choose the transposon's position*/
/************************************************************************/
	for (i = 0; i < no_trans; i++)
	{
		do 
		{
			trans_position1[i] = rnd (0, nreal - 1);
			flag = IsDuplicate (trans_position1, trans_position1[i], i);
		} while (flag == 1);
	}
	for (i = 0; i < no_trans; i++)
	{
		do 
		{
			trans_position2[i] = rnd (0, nreal - 1);
			flag = IsDuplicate (trans_position2, trans_position2[i], i);
		} while (flag == 1);
	}
/************************************************************************/

	/* Select a insert position */
/************************************************************************/
	inserted_position1 = rnd (0, nreal - 1);
	left_size1 = nreal - inserted_position1;
	inserted_position2 = rnd (0, nreal - 1);
	left_size2 = nreal - inserted_position2;
/************************************************************************/

	/* Keep record of the original position */
/************************************************************************/
	for (i = 0; i < nreal; i++)
	{
		operated_position1[i] = i;
		operated_position2[i] = i;
	}

	for (i = 0; i < nreal; i++)
	{
		logo1[i] = 0;
		logo2[i] = 0;
	}
/************************************************************************/

	/* Paste operation */
/************************************************************************/
	if (left_size1 >= no_trans)
	{
		for (i = 0, j = inserted_position1; i < no_trans; i++, j++)
		{
			operated_position1[j] = trans_position2[i];
			logo1[j] = 1;
		}
	}
	else
	{
		for (i = 0, j = inserted_position1; i < no_trans && j < nreal; i++, j++)
		{
			operated_position1[j] = trans_position2[i];
			logo1[j] = 1;
		}
		for (j = 0; i < no_trans; i++, j++)
		{
			operated_position1[j] = trans_position2[i];
			logo1[j] = 1;
		}
	}

	/*
	if (left_size2 >= no_trans)
	{
		for (i = 0, j = inserted_position2; i < no_trans; i++, j++)
		{
			operated_position2[j] = trans_position1[i];
			logo2[j] = 1;
		}
	}
	else
	{
		for (i = 0, j = inserted_position2; i < no_trans && j < nreal; i++, j++)
		{
			operated_position2[j] = trans_position1[i];
			logo2[j] = 1;
		}
		for (j = 0; i < no_trans; i++, j++)
		{
			operated_position2[j] = trans_position1[i];
			logo2[j] = 1;
		}
	}
	*/
	
/************************************************************************/

	/* Normalize the operated individual */
/************************************************************************/
	for (i = 0; i < nreal; i++)
	{
		current_index1 = operated_position1[i];
		current_index2 = operated_position2[i];
		range = max_realvar[i] - min_realvar[i];
		if (logo1[i])
		{
			ind1->xreal[i] = range * information2[current_index1] + min_realvar[i];
		}
		/*
		if (logo2[i])
		{
			ind2->xreal[i] = range * information1[current_index2] + min_realvar[i];
		}
		*/
		ind2->xreal[i] = support[i];
	}
/************************************************************************/

	free (logo1);
	free (logo2);
	free (trans_position1);
	free (trans_position2);
	free (operated_position1);
	free (operated_position2);
	free (information1);
	free (information2);
	free (support);
}

int IsDuplicate (int *trans_position, int check_position, int end)
{
	int i;
	int flag;

	flag = 0;

	for (i = 0; i < end; i++)
	{
		if (trans_position[i] == check_position)
		{
			flag = 1;
		}
	}

	if (flag == 1)
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

int IsInTransposon (int *trans_position, int check_position)
{
	int i;
	int flag;

	flag = 0;
	
	for (i = 0; i < no_trans; i++)
	{
		if (check_position == trans_position[i])
		{
			flag = 1;
		}
	}

	if (flag == 1)
	{
		return 1;
	}
	else
	{
		return 0;
	}
}