/* Routine for mergeing two populations */

# include <stdio.h>
# include <stdlib.h>
# include <math.h>

# include "global.h"
# include "rand.h"

/* Routine to merge two populations into one */
void merge(population *pop1, population *pop2, population *pop3)
{
    int i, k;
    for (i=0; i<popsize; i++)
    {
        copy_ind (&(pop1->ind[i]), &(pop3->ind[i]));
    }
    for (i=0, k=popsize; i<popsize; i++, k++)
    {
        copy_ind (&(pop2->ind[i]), &(pop3->ind[k]));
    }
    return;
}

merge_2 (population *parent_pop, population *jump_pop, population *mixed_pop, int popsize, int jump_size)
{
	int i, k;

	for (i = 0; i < popsize; i++)
	{
		copy_ind (&(parent_pop->ind[i]), &(mixed_pop->ind[i]));
	}
	for (i = 0, k = popsize; i < jump_size; i++, k++)
	{
		copy_ind (&(jump_pop->ind[i]), &(mixed_pop->ind[k]));
	}
	
	return;
}

/* Routine to copy an individual 'ind1' into another individual 'ind2' */
void copy_ind (individual *ind1, individual *ind2)
{
    int i;

    ind2->rank = ind1->rank;
    ind2->crowd_dist = ind1->crowd_dist;

    if (nreal != 0)
    {
        for (i = 0; i < nreal; i++)
        {
            ind2->xreal[i] = ind1->xreal[i];
        }
    }
    for (i = 0; i < nobj; i++)
    {
        ind2->obj[i] = ind1->obj[i];
    }

    return;
}