# include <stdio.h>
# include <stdlib.h>
# include <math.h>

# include "global.h"
# include "rand.h"

void truncation_pop (population *pop1, int size1, population *pop2, int size2)
{
	int i, j, flag, flag2;
	list *elist, *temp_list, *plist;
	double **distance_Matrix, d, temp1, temp2;
	int num_pop1;

	elist = (list *) malloc (sizeof(list));
	distance_Matrix = (double **) malloc (size1 * sizeof(double));

	num_pop1 = size1;

	for(i = 0; i < size1; i++)
	{
		distance_Matrix[i] = (double *) malloc (size1 * sizeof(double));
	}

	elist->index = -1;
	elist->parent = NULL;
	elist->child = NULL;
	temp_list = elist;

	for (i = 0; i < size1; i++)
	{
		insert (temp_list, i);
		temp_list = temp_list->child;
	}

	for (i = 0; i < size1; i++)		// distance_Matrix
	{
		distance_Matrix[i][i] = INF;

		for (j = i + 1; j < size1; j++)
		{
			d = Euclidean_Distance (&(pop1->ind[i]), &(pop1->ind[j]));
			distance_Matrix[i][j] = d;
			distance_Matrix[j][i] = d;
		}
	}

	for (i = 0; i < size1 - size2; i++)
	{
		temp_list = elist->child;
		temp1 = 0.0;

		/* ҵÿһеСֵ */                     
		/************************************************************************/
		while (temp_list != NULL)
		{
			flag = 0;
			temp1 = distance_Matrix[temp_list->index][0];

			for (j = 1; j < size1; j++)
			{
				if ( distance_Matrix[temp_list->index][j] < temp1)
				{
					temp1 =  distance_Matrix[temp_list->index][j];
					flag = j;
				}
			}
			temp_list->index2 = flag;			// index2ڼ¼ÿһСֵк
			temp_list = temp_list->child;
		}

		/************************************************************************/

		temp_list = elist->child;
		temp1 = distance_Matrix[temp_list->index][temp_list->index2];
		temp_list = elist->child;
		plist = temp_list;
		while (temp_list != NULL)		// ҵСֵ֮еСֵ
		{
			if (distance_Matrix[temp_list->index][temp_list->index2] < temp1)
			{
				temp1 = distance_Matrix[temp_list->index][temp_list->index2];
				plist = temp_list;
				temp_list = temp_list->child;
			}
			else
			{
				temp_list = temp_list->child;
			}
		}

		// ѾҵС룬ľǳɶԳֵģˣȷɾһ塣
		if (plist != NULL)
		{
			flag2 = plist->index;
			if (plist->index == 0)
			{
				temp1 = distance_Matrix[plist->index2][plist->index + 1];

				for (j = 2; j < size1; j++)
				{
					if (distance_Matrix[plist->index2][j] < temp1)
					{
						temp1 = distance_Matrix[plist->index2][j];
					}				
				}
			}
			else
			{
				temp1 = distance_Matrix[plist->index2][0];
				for (j = 1; j < size1; j++)
				{
					if ((j != plist->index) && (distance_Matrix[plist->index2][j] < temp1))
					{
						temp1 = distance_Matrix[plist->index2][j];
					}				
				}
			}
			if (plist->index2 == 0)
			{
				temp2 = distance_Matrix[plist->index][plist->index2 + 1];
				for (j = 2; j < size1; j++)
				{
					if (distance_Matrix[plist->index][j] < temp2)
					{
						temp2 = distance_Matrix[plist->index][j];
					}				
				}		
			}
			else
			{
				temp2 = distance_Matrix[plist->index2][0];
				for (j = 1; j < size1; j++)
				{
					if ((j != plist->index2) && (distance_Matrix[plist->index][j] < temp2))
					{
						temp2 = distance_Matrix[plist->index][j];
					}				
				}
			}
			temp_list = elist->child;
			if (temp1 < temp2) 
			{			
				while (temp_list != NULL)
				{
					if (temp_list->index != plist->index2)
					{
						temp_list = temp_list->child;
					}
					else
					{
						for (j = 0; j < size1; j++)
						{
							distance_Matrix[j][plist->index2] = INF;
						}
						temp_list = del (temp_list);
						break;
					}
				}				
			}
			else
			{
				while (temp_list != NULL)
				{
					if (temp_list->index != plist->index)
					{
						temp_list = temp_list->child;
					}
					else
					{
						for (j = 0; j < size1; j++)
						{
							distance_Matrix[j][plist->index] = INF;
						}
						temp_list = del (temp_list);
						break;
					}
				}				
			}
		}		
	}
	temp_list = elist->child;
	i = 0;
	while (temp_list != NULL)
	{
		copy_ind (&(pop1->ind[temp_list->index]), &(pop2->ind[i]));
		i++;
		temp_list = temp_list->child;
	}
	while (elist != NULL)
	{
		temp_list = elist;
		elist = elist->child;
		free (temp_list);
	}
	for (i = 0; i < size1; i++)
	{
		free (distance_Matrix[i]);
	}
	free (distance_Matrix); 
}

void truncation_pop_jump (population *pop1, int size1, population *pop2, int size2, population *jumping_pop, int jump_size)
{
	int i, j, flag, flag2;
	list *elist, *temp_list, *plist;
	double **distance_Matrix, d, temp1, temp2;
	int num_pop1;

//////////////////////////////////////////////////////////////////////////
	int index;
	int *inferior_index, *elite_index;

	inferior_index = (int *) malloc (jump_size * sizeof(int));
	elite_index = (int *) malloc (size2 * sizeof(int));
//////////////////////////////////////////////////////////////////////////

	elist = (list *) malloc (sizeof(list));
	distance_Matrix = (double **) malloc (size1 * sizeof(double));

	num_pop1 = size1;

	for(i = 0; i < size1; i++)
	{
		distance_Matrix[i] = (double *) malloc (size1 * sizeof(double));
	}
	
	elist->index = -1;
    elist->parent = NULL;
    elist->child = NULL;
	temp_list = elist;
	
	for (i = 0; i < size1; i++)
    {
        insert (temp_list, i);
        temp_list = temp_list->child;
    }
	
	for (i = 0; i < size1; i++)		// distance_Matrix
	{
		distance_Matrix[i][i] = INF;

		for (j = i + 1; j < size1; j++)
		{
			d = Euclidean_Distance (&(pop1->ind[i]), &(pop1->ind[j]));
			distance_Matrix[i][j] = d;
			distance_Matrix[j][i] = d;
		}
	}
	
	for (i = 0; i < size1 - size2; i++)
	{
		temp_list = elist->child;
		temp1 = 0.0;

                     /* ҵÿһеСֵ */                     
/************************************************************************/
		while (temp_list != NULL)
		{
			flag = 0;
			temp1 = distance_Matrix[temp_list->index][0];
			
			for (j = 1; j < size1; j++)
			{
				if ( distance_Matrix[temp_list->index][j] < temp1)
				{
					temp1 =  distance_Matrix[temp_list->index][j];
					flag = j;
				}
			}
			temp_list->index2 = flag;			// index2ڼ¼ÿһСֵк
			temp_list = temp_list->child;
		}

/************************************************************************/

		temp_list = elist->child;
		temp1 = distance_Matrix[temp_list->index][temp_list->index2];
		temp_list = elist->child;
		plist = temp_list;
		while (temp_list != NULL)		// ҵСֵ֮еСֵ
		{
			if (distance_Matrix[temp_list->index][temp_list->index2] < temp1)
			{
				temp1 = distance_Matrix[temp_list->index][temp_list->index2];
				plist = temp_list;
				temp_list = temp_list->child;
			}
			else
			{
				temp_list = temp_list->child;
			}
		}

// ѾҵС룬ľǳɶԳֵģˣȷɾһ塣
		if (plist != NULL)
		{
			flag2 = plist->index;
			if (plist->index == 0)
			{
				temp1 = distance_Matrix[plist->index2][plist->index + 1];
				
				for (j = 2; j < size1; j++)
				{
					if (distance_Matrix[plist->index2][j] < temp1)
					{
						temp1 = distance_Matrix[plist->index2][j];
					}				
				}
			}
			else
			{
				temp1 = distance_Matrix[plist->index2][0];
				for (j = 1; j < size1; j++)
				{
					if ((j != plist->index) && (distance_Matrix[plist->index2][j] < temp1))
					{
						temp1 = distance_Matrix[plist->index2][j];
					}				
				}
			}
			if (plist->index2 == 0)
			{
				temp2 = distance_Matrix[plist->index][plist->index2 + 1];
				for (j = 2; j < size1; j++)
				{
					if (distance_Matrix[plist->index][j] < temp2)
					{
						temp2 = distance_Matrix[plist->index][j];
					}				
				}		
			}
			else
			{
				temp2 = distance_Matrix[plist->index2][0];
				for (j = 1; j < size1; j++)
				{
					if ((j != plist->index2) && (distance_Matrix[plist->index][j] < temp2))
					{
						temp2 = distance_Matrix[plist->index][j];
					}				
				}
			}
			temp_list = elist->child;
			if (temp1 < temp2) 
			{			
				while (temp_list != NULL)
				{
					if (temp_list->index != plist->index2)
					{
						temp_list = temp_list->child;
					}
					else
					{
						for (j = 0; j < size1; j++)
						{
							distance_Matrix[j][plist->index2] = INF;
						}
						temp_list = del (temp_list);
						break;
					}
				}				
			}
			else
			{
				while (temp_list != NULL)
				{
					if (temp_list->index != plist->index)
					{
						temp_list = temp_list->child;
					}
					else
					{
						for (j = 0; j < size1; j++)
						{
							distance_Matrix[j][plist->index] = INF;
						}
						temp_list = del (temp_list);
						break;
					}
				}				
			}
		}		
	}
    temp_list = elist->child;
	i = 0;
	while (temp_list != NULL)
    {
		copy_ind (&(pop1->ind[temp_list->index]), &(pop2->ind[i]));
		elite_index[i] = temp_list->index;
		i++;
        temp_list = temp_list->child;
    }

	index = 0;
	/* Щindexarchive */
	for (i = 0; i < size1; i++)
	{
		flag = 1;
		for (j = 0; j < size2; j++)
		{
			if (i == elite_index[j])
			{
				flag = 0;
				break;
			}
		}
		if (flag == 1)
		{
			inferior_index[index] = i;
			index++;
		}
	}

	for (i = 0; i < jump_size; i++)
	{
		copy_ind (&(pop1->ind[inferior_index[i]]), &(jumping_pop->ind[i]));
	}

	while (elist != NULL)
    {
        temp_list = elist;
        elist = elist->child;
        free (temp_list);
    }
	for (i = 0; i < size1; i++)
	{
		free (distance_Matrix[i]);
	}
	free (distance_Matrix);
	free (inferior_index);
	free (elite_index);
}